package com.wd.workoffice.retrofit;


import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.app.BaseMesBean;
import com.wd.workoffice.app.Config;

import io.reactivex.Observable;
import okhttp3.RequestBody;
import retrofit2.http.Body;
import retrofit2.http.POST;
import retrofit2.http.Path;
import retrofit2.http.Query;

/**
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public interface MesApiService {
//    String DOMAIN = Config.DEBUG ? "http://121.36.41.30:9001/" : "http://zwang.bat100.net.cn:8000/";

    String DOMAIN = Config.DEBUG ? "http://114.116.55.221/" : "http://114.116.55.221/";


    /**
     * 工单列表
     *
     * @return
     */
    @POST("/himes/api/msWorkOrder/show/page.json")
    Observable<BaseMesBean> ticketList(@Query("functionId") String functionId, @Body RequestBody requestBody);

    /**
     * 新增
     *
     * @return
     */
    @POST("/himes/api/msWorkOrder/save.json")
    Observable<BaseMesBean> ticketAdd(@Query("functionId") String functionId,
                                      @Query("option") String option,    @Body RequestBody requestBody);

    /**
     * 任务类型-父类
     *
     * @return
     */
    @POST("/himes/api/msJobTypeInfo/show/parentlist.json")
    Observable<BaseMesBean> jobType(@Query("functionId") String functionId);

    /**
     * 任务类型
     *
     * @return
     */
    @POST("/himes/api/msJobTypeInfo/show/list.json")
    Observable<BaseMesBean> jobTypeChild(@Query("functionId") String functionId, @Body RequestBody requestBody);
    /**
     * 日志
     *
     * @return
     */
    @POST("/himes/api/msWorkLogReport/show/listApp.json")
    Observable<BaseMesBean> logList(@Query("functionId") String functionId, @Body RequestBody requestBody);

    /**
     * 日志新增
     *
     * @return
     */
    @POST("/himes/api/msWorkLogReport/save.json")
    Observable<BaseMesBean> logAdd(@Query("functionId") String functionId, @Query("option") String option, @Body RequestBody requestBody);

    /**
     * 工作总结根据jobNo查询
     *
     * @return
     */
    @POST("/himes/api/msWorkSummary/show/{id}.json")
    Observable<BaseMesBean> summaryDetail(@Query("functionId") String functionId, @Path("id") String id);

    /**
     * 工作总结新增
     *
     * @return
     */
    @POST("/himes/api/msWorkSummary/save.json")
    Observable<BaseMesBean> summaryAdd(@Query("functionId") String functionId, @Body RequestBody requestBody);

    /**
     * 工作总结新增
     *
     * @return
     */
    @POST("/himes/api/msCustomerSales/show/page.json")
    Observable<BaseMesBean> clientList(@Query("functionId") String functionId, @Body RequestBody requestBody);
}
