package com.wd.workoffice.ui.activity.mes.ticket;

import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.bigkoo.pickerview.listener.OnTimeSelectListener;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.wd.workoffice.R;
import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.app.BaseMesBean;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.AccountBean;
import com.wd.workoffice.bean.event.AddTicketEvent;
import com.wd.workoffice.bean.mesBean.JobTypeBean;
import com.wd.workoffice.bean.mesBean.MesClientBean;
import com.wd.workoffice.retrofit.RtfUtils;
import com.wd.workoffice.retrofit.WorkObserver;
import com.wd.workoffice.ui.adapter.JobTypeAdapter;
import com.wd.workoffice.util.DialogUtils;
import com.wd.workoffice.util.PickTimeUtils;
import com.wd.workoffice.util.WorkUtils;

import org.greenrobot.eventbus.EventBus;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import flexible.xd.android_base.utils.TimeUtils;
import io.reactivex.disposables.Disposable;

/**
 * 工单新增
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class MesTicketAddActivity extends WorkToolBarActivity {
    @BindView(R.id.tv_save)
    TextView tvSave;
    @BindView(R.id.tv_submit)
    TextView tvSubmit;
    @BindView(R.id.ll_bottom)
    LinearLayout llBottom;
    @BindView(R.id.tv_code)
    TextView tvCode;
    @BindView(R.id.tv_client)
    TextView tvClient;
    @BindView(R.id.rl_client)
    RelativeLayout rlClient;
    @BindView(R.id.tv_company)
    TextView tvCompany;
    @BindView(R.id.rl_company)
    RelativeLayout rlCompany;
    @BindView(R.id.tv_manager)
    TextView tvManager;
    @BindView(R.id.rl_manager)
    RelativeLayout rlManager;
    @BindView(R.id.et_desc)
    EditText etDesc;
    @BindView(R.id.tv_take_on)
    TextView tvTakeOn;
    @BindView(R.id.rl_take_on)
    RelativeLayout rlTakeOn;
    @BindView(R.id.et_person)
    EditText etPerson;
    @BindView(R.id.tv_start_time)
    TextView tvStartTime;
    @BindView(R.id.tv_end_time)
    TextView tvEndTime;
    @BindView(R.id.tv_time)
    TextView tvTime;
    @BindView(R.id.rl_time)
    RelativeLayout rlTime;
    @BindView(R.id.rl_job)
    RelativeLayout rlJob;
    @BindView(R.id.tv_job)
    TextView tvJob;
    @BindView(R.id.rv_job)
    RecyclerView rvJob;
    private AccountBean dataBean;
    private Map<String, Object> param;
    private QMUIDialog.MenuDialogBuilder jobDialog;
    private JobTypeBean chooseJob;
    private MesClientBean.ListBean chooseClient;

    @Override
    protected void initView() {
        ButterKnife.bind(this);
        param = WorkUtils.simpleParam();
        jobDialog = DialogUtils.listDialog(this);
        rvJob.setLayoutManager(new LinearLayoutManager(this, RecyclerView.VERTICAL, false));
    }

    @Override
    protected void initData() {
        getJobType();
    }

    private void getJobType() {
        RtfUtils.getMesRtf().jobType("1").compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {


            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
                List<JobTypeBean> jobTypeList = JSON.parseArray(data.getData().toString(), JobTypeBean.class);
                List<String> jobNameList = new ArrayList<>();
                for (JobTypeBean jobTypeBean : jobTypeList) {
                    jobNameList.add(jobTypeBean.getJobTypeName());
                }
                jobDialog.addItems(jobNameList.toArray(new String[jobNameList.size()]), new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        chooseJob = jobTypeList.get(which);
                        tvJob.setText(jobNameList.get(which));
                        getJobTypeChild(chooseJob.getJobTypeCode());
                        dialog.dismiss();
                    }
                });
            }
        });
    }

    private void getJobTypeChild(String jobTypeCode) {
        Map<String, Object> param = WorkUtils.simpleParam();
        param.put("jobTypeCode", jobTypeCode);
        RtfUtils.getMesRtf().jobTypeChild("1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {


            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
                List<JobTypeBean> jobTypeList = JSON.parseArray(data.getData().toString(), JobTypeBean.class);
                JobTypeAdapter jobTypeAdapter = new JobTypeAdapter(R.layout.item_job_type, jobTypeList);
                jobTypeAdapter.bindToRecyclerView(rvJob);
            }
        });
    }

    @Override
    protected void initEvent() {
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_mes_ticket_add;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // TODO: add setContentView(...) invocation
        ButterKnife.bind(this);
    }

    @OnClick({R.id.tv_save, R.id.tv_submit, R.id.tv_start_time, R.id.tv_end_time, R.id.rl_job, R.id.rl_client, R.id.rl_company, R.id.rl_manager, R.id.rl_take_on})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.tv_save:
                jobDialog.show();
                break;
            case R.id.tv_submit:
                if (chooseClient == null) {
                    toast("请选择客户");
                    return;
                }
                if (chooseJob == null) {
                    toast("请选择任务类别");
                    return;
                }
                param.put("customerUserCode", chooseClient.getCustomerCode());
                param.put("customerUserName", chooseClient.getCustomerName());
                param.put("salesCompanyCode", chooseClient.getSalesCompanyCode());
                param.put("salesCompanyName", chooseClient.getCustomerName());
                param.put("salesManagerCode", chooseClient.getSalesManagerCode());
                param.put("salesManagerName", chooseClient.getSalesManagerName());
                param.put("jobTypeId", chooseJob.getJobTypeCode());
                param.put("jobTypeName", chooseJob.getJobTypeName());
                param.put("jobDescription", etDesc.getText().toString());
                param.put("peopleCount", etPerson.getText().toString());
                param.put("jobStatus", 1);
                submit();
                break;
            case R.id.rl_job:
                jobDialog.show();
                break;
            case R.id.rl_client:
                startActivityForResult(MesTicketClientActivity.class, 10001);
                break;
            case R.id.rl_company:
                break;
            case R.id.rl_manager:
                break;
            case R.id.rl_take_on:
                break;
            case R.id.tv_start_time:
                PickTimeUtils.showPickThree(this, new OnTimeSelectListener() {
                    @Override
                    public void onTimeSelect(Date date, View v) {
                        tvStartTime.setText(TimeUtils.date2String(date, new SimpleDateFormat("yyyy-MM-dd")));
                    }
                }).show();
                break;
            case R.id.tv_end_time:
                PickTimeUtils.showPickThree(this, new OnTimeSelectListener() {
                    @Override
                    public void onTimeSelect(Date date, View v) {
                        tvEndTime.setText(TimeUtils.date2String(date, new SimpleDateFormat("yyyy-MM-dd")));
                    }
                }).show();
                break;
        }
    }

    private void submit() {
        RtfUtils.getMesRtf().ticketAdd("1", "1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {


            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
                toast("添加成功");
                EventBus.getDefault().post(new AddTicketEvent());
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 10001 && resultCode == 10001) {
            chooseClient = JSON.parseObject(data.getStringExtra("data"), MesClientBean.ListBean.class);
            tvClient.setText(chooseClient.getCustomerName());
            tvCompany.setText(chooseClient.getSalesCompanyName());
            tvManager.setText(chooseClient.getSalesManagerName());
        }
    }
}
