package com.wd.workoffice.ui.activity.mes.ticket;

import android.view.Menu;
import android.view.MenuItem;
import android.widget.EditText;
import android.widget.TextView;

import com.alibaba.fastjson.JSON;
import com.wd.workoffice.R;
import com.wd.workoffice.app.BaseBean;
import com.wd.workoffice.app.BaseMesBean;
import com.wd.workoffice.app.WorkToolBarActivity;
import com.wd.workoffice.bean.AccountBean;
import com.wd.workoffice.retrofit.RtfUtils;
import com.wd.workoffice.retrofit.WorkObserver;
import com.wd.workoffice.util.WorkUtils;

import java.util.Arrays;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;
import flexible.xd.android_base.network.rtfhttp.Transformer;
import io.reactivex.disposables.Disposable;

/**
 * 工单新增
 * author : flexible
 * email : lgd19940421@163.com
 * github: https://github.com/FlexibleXd
 **/
public class MesTicketAddLogActivity extends WorkToolBarActivity {
    @BindView(R.id.tv_code)
    TextView tvCode;
    @BindView(R.id.tv_time)
    TextView tvTime;
    @BindView(R.id.tv_create_person)
    TextView tvCreatePerson;
    @BindView(R.id.et_content)
    EditText etContent;
    @BindView(R.id.et_question_desc)
    EditText etQuestionDesc;
    @BindView(R.id.et_client)
    EditText etClient;
    private Map<String, Object> param;

    @Override
    protected void initView() {
        ButterKnife.bind(this);
    }

    @Override
    protected void initData() {
        param = WorkUtils.simpleParam();
        param.put("jobNo", getIntent().getStringExtra("id"));
    }

    private void submit() {
        RtfUtils.getMesRtf().logAdd("", "1", WorkUtils.convertMapToBody(param)).compose(Transformer.schedule()).subscribe(new WorkObserver<BaseMesBean>() {


            @Override
            public void doOnSubscribe(Disposable d) {
            }

            @Override
            public void onFail(String errorMsg) {
                hideLoading();
                toast(errorMsg);
            }

            @Override
            public void onSuccess(BaseMesBean data) {
                hideLoading();
                if (!data.isSuccess()) {
                    toast(data.getMessage());
                    return;
                }
            }
        });
    }

    @Override
    protected void initEvent() {
    }

    @Override
    protected int layoutId() {
        return R.layout.activity_mes_ticket_log_add;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.menu_report, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.report:
                String client = etClient.getText().toString();
                String content = etContent.getText().toString();
                String desc = etQuestionDesc.getText().toString();
                param.put("customerDemand", client);
                param.put("jobContent", content);
                param.put("problemDescription", desc);
//                param.put("attachments", Arrays.asList("https://image.baidu.com/search/redirect?tn=redirect&word=j&juid=60A17C&sign=ckwboawzac&url=http%3A%2F%2Fwww.he-nan.com%2Fwtx%2Fswaxd%2Fnew-126233.html&bakfurl1=http%3A%2F%2Fwww.jnhsgc.com%2Fwtx%2Fswaxd%2Fshow%2F2188241.html&bakfurl2=http%3A%2F%2Fwww.10huan.com%2Fwtx%2Fswaxd%2Fnew-1240701.html&objurl=https%3A%2F%2Ftimgsa.baidu.com%2Ftimg%3Fimage%26quality%3D80%26size%3Db9999_10000%26sec%3D1587918679912%26di%3D8f01c77314881dad317d1cbda58cd0bf%26imgtype%3D0%26src%3Dhttp%253A%252F%252Fimg.yzt-tools.com%252F20190218%252Fca736a78109decf300cbaf239cc32545.jpg"));
                submit();
                break;
        }
        return super.onOptionsItemSelected(item);
    }
}
